/// <reference types="node" />
import * as http from "http";
import { JsonBody } from "./body/json";
import { TextBody } from "./body/text";
import { ErrorWithBody } from "./errors/body";
import { ErrorWithStatusCode } from "./errors/status";
import { useExpress } from "./express";
import { ErrorHandler, Handler, ICtx, Methods, Middleware, Router } from "./router";
export { Router, ErrorWithStatusCode, ErrorWithBody, useExpress, JsonBody, TextBody, Methods, Handler, Middleware, ICtx };
export interface IListenOptions {
    hostname?: string;
}
export declare const defaultErrorHandler: ErrorHandler;
export declare class Routex extends Router {
    errorHandler: ErrorHandler;
    handler: (req: http.IncomingMessage, res: http.ServerResponse) => Promise<void>;
    listen(port?: number | string, { hostname }?: IListenOptions): Promise<{
        close: () => Promise<{}>;
        port: number | null;
        server: http.Server;
    }>;
}
